"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactNative = require("react-native");
var _reactNativeGestureHandler = require("react-native-gesture-handler");
var _reactNativeReanimated = _interopRequireWildcard(require("react-native-reanimated"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
const calculateValue = (position, min, max, step, height) => {
  'worklet';

  let sliderPosition = height - position;
  sliderPosition = Math.min(Math.max(sliderPosition, 0), height);
  let value = sliderPosition / height * (max - min) + min;
  value = Math.round(value / step) * step;
  value = Math.min(Math.max(value, min), max);
  return value;
};
const RNVerticalSlider = /*#__PURE__*/_react.default.forwardRef(({
  min = 0,
  max = 100,
  step = 1,
  width = 350,
  height = 30,
  borderRadius = 5,
  maximumTrackTintColor = '#3F2DA5',
  minimumTrackTintColor = '#77ADE6',
  disabled = false,
  onChange = () => {},
  onComplete = () => {},
  value: currentValue = 0,
  showIndicator = false,
  renderIndicatorHeight = 40,
  renderIndicator = () => null,
  containerStyle = {},
  sliderStyle = {},
  animationConfig = {
    damping: 15
  }
}, ref) => {
  let point = (0, _reactNativeReanimated.useSharedValue)(currentValue);
  let disabledProp = (0, _reactNativeReanimated.useSharedValue)(disabled);
  // Memoized BaseView styles
  const calculateBaseView = () => ({
    height,
    width,
    borderRadius,
    backgroundColor: maximumTrackTintColor
  });
  const baseViewStyle = _react.default.useMemo(calculateBaseView, [borderRadius, height, maximumTrackTintColor, width]);
  // Gesture handler
  const handleGesture = type => eventY => {
    if (disabledProp.value) return;
    let value = calculateValue(eventY, min, max, step, height);
    point.value = (0, _reactNativeReanimated.withSpring)(value, animationConfig);
    (0, _reactNativeReanimated.runOnJS)(type === 'BEGIN' || type === 'CHANGE' ? onChange : onComplete)(value);
  };
  const onGestureStart = event => handleGesture('BEGIN')(event.y);
  const onGestureChange = event => handleGesture('CHANGE')(event.y);
  const onGestureEnd = event => handleGesture('END')(event.y);
  const panGesture = _reactNativeGestureHandler.Gesture.Pan().onBegin(onGestureStart).onChange(onGestureChange).onEnd(onGestureEnd).onFinalize(onGestureEnd).runOnJS(true);
  // Ref methods
  _react.default.useImperativeHandle(ref, () => ({
    setValue: value => {
      point.value = (0, _reactNativeReanimated.withSpring)(value, animationConfig);
      onChange(value);
    },
    setState: state => {
      disabledProp.value = state;
    }
  }));
  // slider styles
  const slider = (0, _reactNativeReanimated.useAnimatedStyle)(() => {
    let heightPercentage = (point.value - min) / (max - min) * 100;
    const style = {
      backgroundColor: minimumTrackTintColor,
      height: `${heightPercentage}%`
    };
    return style;
  }, [point.value]);
  // indicator styles
  const indicator = (0, _reactNativeReanimated.useAnimatedStyle)(() => {
    const style = {};
    if (showIndicator) {
      let bottom = (point.value - min) / (max - min) * height;
      bottom = Math.min(Math.max(bottom, 0), height - renderIndicatorHeight);
      style.bottom = bottom;
    }
    return style;
  }, [point.value]);
  return /*#__PURE__*/_react.default.createElement(_reactNativeGestureHandler.GestureDetector, {
    gesture: panGesture
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [baseViewStyle, containerStyle]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [baseViewStyle, styles.box, sliderStyle]
  }, /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.View, {
    style: [styles.box, slider]
  })), /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.View, {
    style: [styles.indicator, indicator]
  }, renderIndicator(point.value))));
});
const styles = _reactNative.StyleSheet.create({
  box: {
    overflow: 'hidden',
    position: 'absolute',
    bottom: 0,
    width: '100%'
  },
  indicator: {
    position: 'absolute'
  }
});
var _default = exports.default = RNVerticalSlider;
//# sourceMappingURL=Slider.js.map